
import random
import math

from pyglet.gl import *

import cocos.euclid as eu

from svgnode import SVGNode
from data import filepath
import squirtle
from rect import Rect




class Evil(SVGNode):
    change_directions = False
    def __init__(self, bounding_rect):
        main_svg = squirtle.load_layers(filepath(self.svg_filename), 
                anchor_x = 'center',
                anchor_y = 'center',
            )
        super(Evil,self).__init__(main_svg['background'])
        self.bounding_rect = bounding_rect
        self.position = self.bounding_rect.center
        #self.update = self.update_stuff()
        #self.update.send(None)

    def update_stuff(self):
        move_dir = eu.Vector2(-0.5, 0.1)
        self.position = self.bounding_rect.center

        while True:
            dt = yield
            #move_dir =  move_dir + eu.Vector2(random.random()*.1 - .05, random.random() * .1 - .05)
            new_pos = self.position + self.fastness * dt * move_dir
            loop_count = 0
            while not self.bounding_rect.contains(*new_pos):
                if new_pos.x < self.bounding_rect.left or \
                        new_pos.x > self.bounding_rect.right:
                    move_dir.x = -move_dir.x #+ random.uniform(-.8,.8)

                if new_pos.y < self.bounding_rect.bottom or \
                        new_pos.y > self.bounding_rect.top:
                    move_dir.y = -move_dir.y + random.uniform(-.8,.8)
        
                new_pos = self.position + self.fastness * dt * move_dir
                loop_count += 1
                if loop_count > 10:
                    new_pos = self.position 
                    move_dir = eu.Vector2(0.01, 0)
                    break
                

            if self.change_directions and move_dir.x < 0:
                self.scale = (-1, 1)
            else:
                self.scale = (1,1)


            self.position = new_pos

    def contains(self, x, y):
        r = Rect(self.position[0], self.position[1],self.svg.width, self.svg.height)
        r.center = self.position
        return r.contains(x,y)

class Crab(Evil):
    svg_filename = 'crab.svg'
    fastness = .2


class Fish(Evil):
    change_directions = True
    svg_filename = 'fish_1.svg'
    fastness = .1

class Octopus(Evil):
    svg_filename = 'octopus.svg'
    fastness = .2
