
import cocos

import squirtle

from data import filepath

from svgnode import SVGNode

class Intro(cocos.scene.Scene):
    def __init__(self):
        super(Intro,self).__init__()

        colorLayer1 = cocos.layer.ColorLayer(32,32,255,255)
        self.add(colorLayer1)
        self.add(StuffLayer())

class StuffLayer(cocos.layer.Layer):
    is_event_handler = True
    def __init__(self):
        super(StuffLayer, self ).__init__()

        neptune_layers = squirtle.load_layers(filepath('neptune.svg'),
                anchor_x = 'left',
                anchor_y = 'bottom',
                )
        neptune = neptune_layers['background']
        
        svg = SVGNode(neptune)
        self.add(svg)
        svg.position = 0, 0 

        text = "Someone has stolen the tines (prongs) of Neptune three favourite tridents. Can you retrieve these Nine Tines?"
        intro_label = cocos.text.RichLabel(text, (350, 100) , 
                width = 300, 
                multiline = True,
                font_name = "BirthdayGreetz",
                font_size = 18,
                )
        self.add(intro_label)

    def on_key_press(self, key, mod):
        cocos.director.director.pop()


