
import cocos
import pyglet

from cocos.menu import Menu, MenuItem, ToggleMenuItem, CENTER
from cocos.menu import shake, shake_back

from cocos.director import director
from cocos.layer import ColorLayer


from level import Level, load_level

from intro import Intro


class MainMenu(Menu):
    def __init__( self ):
        super( MainMenu, self ).__init__("Neptues's Nine Tines" )

        self.menu_valign = CENTER
        self.menu_halign = CENTER

        self.font_title["font_name"] = "BirthdayGreetz"
        self.font_item["font_name"] = "BirthdayGreetz"
        self.font_item_selected["font_name"] = "BirthdayGreetz"

        items = []
        items.append(MenuItem("Introduction", self.show_intro ))
        for level_number in range(1,3):
            items.append(MenuItem('Level %d' % level_number, load_level(level_number)))

        items.append( MenuItem('Exit', self.on_quit ) )

        self.create_menu( items, shake(), shake_back() )
        self._intro = None

    def on_quit( self ):
        pyglet.app.exit()

    def show_intro(self):
        if self._intro is None:
            self._intro = Intro()
        director.push(self._intro)



class MenuScene(cocos.scene.Scene):
    def __init__(self):
        super(MenuScene,self).__init__()

        colorLayer1 = ColorLayer(32,32,255,255)
        self.add(colorLayer1)

        menu = MainMenu() 
        self.add(menu)




