
from pyglet.gl import *
from svgnode import SVGNode
import squirtle
from rect import Rect

class SpriteFromPaths(SVGNode):
    points = 1
    is_tine = False
    def __init__(self, paths):
        svg = squirtle.SVG('temp')
        
        svg.paths = paths
        svg.dirty = True

        svg.disp_list = glGenLists(1)
        glNewList(svg.disp_list, GL_COMPILE)
        svg.render_slowly()
        glEndList()

        min_x = min_y = 999999999
        max_x = max_y = -999999999
        for path in svg.paths:
            if not path.tris: continue
            for x, y in path.tris:
                min_x = min(x, min_x)
                max_x = max(x, max_x)
                min_y = min(y, min_y)
                max_y = max(y, max_y)
        self.min_x = min_x
        self.min_y = min_y
        self.max_x = max_x
        self.max_y = max_y
        self.width = max_x - min_x
        self.height = max_y - min_y

        self.offset_in_file = svg.paths[0].get_box().x, svg.paths[0].get_box().y

        super(SpriteFromPaths, self).__init__(svg)

    def draw(self,*argv, **kwargs):
        glPushMatrix() 
        glTranslatef(-self.offset_in_file[0],-self.offset_in_file[1],0)
        glTranslatef(-self.width/2, -self.height/2, 0)
        super(SpriteFromPaths, self).draw(*argv, **kwargs)
        glPopMatrix()

    def contains(self, x, y):
        r = Rect(self.position[0], self.position[1],self.width, self.height)
        r.center = self.position
        return r.contains(x,y)
        

class Clam(SpriteFromPaths):
    points = 1

class Tine(SpriteFromPaths):
    is_tine = True

class Tine_silver(Tine):
    points = 10

