import cocos
from pyglet.gl import *




class SVGNode(cocos.cocosnode.CocosNode):
    def __init__(self, svg):
        super(SVGNode,self).__init__()
        self.svg = svg
        if hasattr(self.svg, 'transform'):       
            if self.svg.transform.values[5] == 0:
                self.svg.transform.values[5] = -self.svg.height/2


    def draw(self):
        glPushMatrix() 

        glTranslatef(self.position[0],self.position[1],0)

        glRotatef( -self._rotation, 0, 0, 1)
        scale = self.scale
        if scale != 1:
            try:
                glScalef(scale[0], scale[1], 1)
            except TypeError:
                glScalef(scale, scale, 1)
        
        self.svg.draw(0,0)

        glPopMatrix()


