import unittest

import whitei


def temp_init(self):
    self._rotation = 0
    self._scale = 1,1
    self._direction = 0
    pass


whitei.Whitei.__init__ = temp_init



class TestWhitei(unittest.TestCase):
    def test_direction_simple(self):
        w = whitei.Whitei()
        w.direction = 0
        self.assertEquals(w.rotation, 0)
        self.assertEquals(w.scale, (1,1))

    def test_direction_90(self):
        w = whitei.Whitei()
        w.direction = -90
        self.assertEquals(w.rotation, -45)

    def test_direction_45(self):
        w = whitei.Whitei()
        w.direction = -45
        self.assertEquals(w.rotation, -22.5)

    def test_direction__90(self):
        w = whitei.Whitei()
        w.direction = 90
        self.assertEquals(w.rotation, 45)

    def test_direction_backwards(self):
        w = whitei.Whitei()
        w.direction = -180
        self.assertEquals(w.scale, (-1,1))
        self.assertEquals(w.rotation, 0)

    def test_direction_backwards_down_little_bit(self):
        w = whitei.Whitei()
        w.direction = 135
        self.assertEquals(w.scale, (-1,1))
        self.assertEquals(w.rotation, -22.5)

    def test_direction_backwards_down_little_up(self):
        w = whitei.Whitei()
        w.direction = -135
        self.assertEquals(w.scale, (-1,1))
        self.assertEquals(w.rotation, 22.5)


    def test_direction_changing_up(self):
        w = whitei.Whitei()
        w.direction = 0
        w.direction = 90
        self.assertEquals(w.rotation, 45)
        self.assertEquals(w.scale, (1,1))

    def test_direction_changing_up(self):
        w = whitei.Whitei()
        w.direction = -135
        w.direction = 90
        self.assertEquals(w.rotation, 45)
        self.assertEquals(w.scale, (-1,1))

